package icfp2001;

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
public class ColorNesting implements Runnable{

private Thread           thread;
private String s = null;
private boolean ende = false;

private String[] startTags = {"<r>", "<g>","<b>", "<c>","<m>","<y>",
                              "<k>","<w>"};
private String[] endTags =   {"</r>","</g>", "</b>",
                              "</c>","</m>","</y>", "</k>","</w>"};





  public ColorNesting() {
  }

/**
 * Starts the Thread.
 */
public void startMe(String s) {
   this.s = s;

   thread = new Thread( this );
   thread.start();
}


/**
 * Returns the String.
 */
public String getString() {
   return s;
}

/**
 * Checks the Thread: running?
 */
public boolean isAlive() {
   if ( thread != null )
      return thread.isAlive();
   return false;
}


/**
 * Starts the Thread.
 */
public void run() {
   boolean colored = true;
   boolean open = false;
   int beg = 0;
   int end1;
   int end2;
   int start2;
   int cnt;
   char act;
   int counter = 0;

   for (int i=0; i<startTags.length; i++)
   {
      while (((beg=s.indexOf(startTags[i], beg)) != -1) && (!ende)){
        colored = true;
        beg++;
        end1=s.indexOf(endTags[i], beg);
        end2=s.indexOf(endTags[i], end1+1);
        start2 = s.indexOf(startTags[i], beg);

        //no second end tag
        if((end2==-1)||(end1==-1)){
          colored = false;
          continue;
        }
        cnt = end1 + 4;
        if(cnt > start2) {
          colored = false;
        }
        for(int u=cnt; u<start2;){
            act = s.charAt(u);
            if(act == '<'){
              u++;
              act = s.charAt(u);
              //close tag
              if (act == '/'){
                 u++;
                 act = s.charAt(u);
                 //color tag
                 if((act=='r')||(act=='g')||(act=='b')||(act=='c')||(act=='m')||(act=='y')||(act=='k')||(act=='w')){
                 open = false;
                  counter --;
                  u += 2;
                 }
                 //long tag
                 else if((s.charAt(i)=='E')||(s.charAt(i)=='T')||(s.charAt(i)=='P')){
                  u += 3;
                 }
                 //short tag
                 else
                  u += 2;
              }
              //open color tag
              else if((act=='r')||(act=='g')||(act=='b')||(act=='c')||(act=='m')||(act=='y')||(act=='k')||(act=='w')){
                open = true;
                counter++;
                u += 2;
              }
            }//if <
            else{
              u++;
              //check for uncolored Text (not between a color tag)
              if((counter==0)){//||(open)){
                colored = false;
              }
            }
        }//for
        if(colored){
          s = deleteTag(s.indexOf(startTags[i], end1), endTags[i], s);
          s = deleteTag(end1, endTags[i], s);
          beg = 0;
        }
        colored = true;
      }//while
   }//for
}


/**
 * Deletes a Tag in a Document.
 */
private String deleteTag(int index, String tag, String s) {
   StringBuffer newString = new StringBuffer(s);
   for (int i=0; i<tag.length(); i++)
      newString.deleteCharAt(index);

   return newString.toString();
}

public void breakIt() {
   this.ende=true;
}
}