package icfp2001;


/* *************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

public class DelUselessSize implements Runnable {

private Thread           thread;
private String s = null;
private boolean ende = false;

private String[] startTags = {"<0>","<PL>","<1>",
                              "<2>","<3>", "<4>","<5>", "<6>","<7>","<8>",
                              "<9>","<r>", "<g>","<b>", "<c>","<m>","<y>",
                              "<k>","<w>"};
private String[] endTags =   {"</0>","</PL>",
                              "</1>","</2>","</3>", "</4>","</5>", "</6>",
                              "</7>","</8>","</9>", "</r>","</g>", "</b>",
                              "</c>","</m>","</y>", "</k>","</w>"};


  public DelUselessSize() {
  }

/**
 * Starts the Thread.
 */
public void startMe(String s) {
   this.s = s;

   thread = new Thread( this );
   thread.start();
}


/**
 * Returns the String.
 */
public String getString() {
   return s;
}

/**
 * Checks the Thread: running?
 */
public boolean isAlive() {
   if ( thread != null )
      return thread.isAlive();
   return false;
}


/**
 * Starts the Thread.
 */
public void run() {
   for (int i=0; i<startTags.length; i++)
   {
      int beg=0;
      int end1=0;
      int end2 = 0;
      int start2=0;
      while (((beg=s.indexOf(startTags[i], beg)) != -1) && (!ende))
      {
         end1 = findTag(beg, s, i);
         start2 = beg+1;
         while(true){
            start2 = s.indexOf(startTags[i], start2);
            end2 = findTag(start2, s, i);
            if((start2<end1)&&(start2!=-1)){
              if(noSpace(beg, start2)){
                if(noSpace(end2, end1)){
                  s = deleteTag(end2, endTags[i]);
                  s = deleteTag(start2, startTags[i]);
                  end1 = findTag(beg, s, i);
                }//if noSpace end
                else {

                  break;
                }
              }//if no space start
              else {
                break;
              }
            }//if start<end
            else
              break;
         }//while true;
         ++beg;
      }//while
   }//for
}


/**
 * Deletes a Tag in a Document.
 */
private String deleteTag(int index, String tag) {
   StringBuffer newString = new StringBuffer(s);
   for (int i=0; i<tag.length(); i++)
      newString.deleteCharAt(index);

   return newString.toString();
}


/**
 * checks for no spaces
 */
 private boolean noSpace(int st, int end){
  char act = '0';
  for(int i=st; i<end;){
     act = s.charAt(i);
     if(act == '<'){
        i++;
        act = s.charAt(i);
        //close tag
        if (act == '/'){
          i++;
          act = s.charAt(i);
           //long tag
            if((s.charAt(i)=='E')||(s.charAt(i)=='T')||(s.charAt(i)=='P')){
                i += 3;
            }
            //short tag
            else
               i += 2;
         }
         //open long tag
         else if((s.charAt(i)=='E')||(s.charAt(i)=='T')||(s.charAt(i)=='P')){
               i += 3;
         }
         else{
            i += 2;
         }
      }//if <
      else{
        return false;
      }
  }
  return true;
 }



/**
 * find the close tag to the given start tag
 */
 private int findTag(int pos, String s, int i){
    int end=pos+1;
    int oldPos=0;

    pos++;
    while(true){
      if(pos<1) break;

      pos=s.indexOf(startTags[i] ,pos);
      end=s.indexOf(endTags[i], end);
      if((pos!=-1)&&(pos<end)){
        pos++;
        end++;
        end=s.indexOf(endTags[i], end);
        pos=s.indexOf(startTags[i] ,pos);
      }
      else
       break;
    }

    return end;
 }

public void breakIt() {
   this.ende=true;
}
}