package icfp2001;

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
public class EMElimination implements Runnable {

private Thread           thread;
private String s = null;
private boolean ende = false;

private String[] startTags = {"<EM>","<B>","<I>","<PL>","<S>","<TT>","<0>","<1>",
                              "<2>","<3>", "<4>","<5>", "<6>","<7>","<8>",
                              "<9>","<r>", "<g>","<b>", "<c>","<m>","<y>",
                              "<k>","<w>"};
private String[] endTags =   {"</EM>","</B>","</I>","</PL>","</S>","</TT>","</0>",
                              "</1>","</2>","</3>", "</4>","</5>", "</6>",
                              "</7>","</8>","</9>", "</r>","</g>", "</b>",
                              "</c>","</m>","</y>", "</k>","</w>"};

  public EMElimination() {
  }

public void startMe(String s) {
   this.s = s;

   thread = new Thread( this );
   thread.start();
}

/**
 * Returns the String.
 */
public String getString() {
   return s;
}

  public void run(){
      int beg = 0;
      int search = 0;
      int counter = 0;
      int cls = 0;
      int save = 0;


      while (((beg=s.indexOf(startTags[0], beg)) != -1) && (!ende))
      {
         save = beg;
         beg++;
         counter = 0;
         search = 0;
         while(((search=s.indexOf(startTags[4], search))!=-1)){
           if(beg>search){
            search ++;
            counter++;
           }
           else break;
         }
         search = 0;
         if(counter>0){
          while(((search=s.indexOf(endTags[4], search))!=-1)){
           if(beg>search){
            search ++;
            counter--;
           }
           else break;
          }
         }
        if(counter!=0){
             cls = s.indexOf(endTags[0], beg);
             s = deleteTag(cls, endTags[0], s);
             s = deleteTag(beg-1, startTags[0], s);
        }
        //******************** findDouble *************************************
        int next;
        int dif = 0;
        boolean dl = true;


        next = s.indexOf(startTags[0], beg);
        for(int u=beg+2; u<next;){
          dif++;
          u++;
          if(s.charAt(u)!='<'){
              dl = false;
              break;
          }
          u++;
          if((s.charAt(u)=='T')||(s.charAt(u)=='P')){
              u += 2;;
          }
          else u++;
        }
        if(dl&&(next!=-1)&&(beg!=-1)){
             int tmp=save+1;
             for(int z=0; z<dif; z++){
                tmp = (s.indexOf(endTags[0], tmp))+1;
             }
             s = deleteTag(findTag(save+1, s), endTags[0],s);
             s = deleteTag(findTag(s.indexOf("<EM>", save+1) ,s), "</EM>", s);
             s = deleteTag(s.indexOf("<EM>", save+1), "<EM>", s);
             s = deleteTag(save, startTags[0],s);
             dif = 0;
        }
      }//while
  }

  public boolean isAlive() {
        if ( thread != null )
            return thread.isAlive();

        return false;
    }

/**
 * Deletes a " " in a Document.
 */
private String deleteTag(int index, String tag, String s) {
   StringBuffer newString = new StringBuffer(s);
   for (int i=0; i<tag.length(); i++)
      newString.deleteCharAt(index);

   return newString.toString();
}

/**
 * find the close tag to the given start tag
 */
 private int findTag(int pos, String s){
    int end=pos;
    int oldPos=0;

    pos++;
    while(true){
      if(end == -1) break;

      oldPos = end;
      if((pos=s.indexOf("<EM>" ,pos))<(end=s.indexOf("</EM>", end))){
        pos++;
        end++;
      }
      else break;
    }
    return oldPos-1;
 }

public void breakIt() {
   this.ende=true;
}

}