package icfp2001;

class RedundancyElimination implements Runnable {

private Thread           thread;
private String s = null;
private boolean ende = false;

private String[] startTags = {"<B>","<I>","<S>","<TT>"};
private String[] endTags =   {"</B>","</I>","</S>","</TT>"};


/**
 * Starts the Thread.
 */
public void startMe(String s) {
   this.s = s;

   thread = new Thread( this );
   thread.start();
}


/**
 * Returns the String.
 */
public String getString() {
   return s;
}

/**
 * Checks the Thread: running?
 */
public boolean isAlive() {
   if ( thread != null )
      return thread.isAlive();
   return false;
}

/**
 */
public void breakIt() {
   this.ende=true;
}


/**
 * Starts the Thread.
 */
public void run() {
   for (int i=0; i<startTags.length; i++)
   {
      int beg=0;
      while (((beg=s.indexOf(startTags[i], beg)) != -1) && (!ende))
      {
         beg++;
         while ((s.indexOf(startTags[i], beg) < s.indexOf(endTags[i], beg)) &&
               (s.indexOf(startTags[i], beg)!=-1) &&
               (s.indexOf(endTags[i], beg)!=-1)) {
            s = deleteTag(s.indexOf(startTags[i], beg), startTags[i]);
            s = deleteTag(s.indexOf(endTags[i], beg), endTags[i]);
         }
         if (s.indexOf(endTags[i], beg)!=-1)
            beg=s.indexOf(endTags[i], beg);
      }
   }
}


/**
 * Deletes a Tag in a Document.
 */
private String deleteTag(int index, String tag) {
   StringBuffer newString = new StringBuffer(s);
   return newString.delete(index, index+tag.length()).toString();
}

}//class
