package icfp2001;

/* *************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

public class Underline implements Runnable {

private Thread           thread;
private String s = null;
private boolean ende = false;

  public Underline() {
  }


/**
 * Starts the Thread.
 */
public void startMe(String s) {
   this.s = s;

   thread = new Thread( this );
   thread.start();
}


/**
 * Returns the String.
 */
public String getString() {
   return s;
}

/**
 * Checks the Thread: running?
 */
public boolean isAlive() {
   if ( thread != null )
      return thread.isAlive();
   return false;
}


/**
 * Starts the Thread.
 */
public void run() {
      int beg=0;
      int end = 0;
      int tmp = 0;
      int cnt = 0;
      int pl = 0;
      boolean bPL = false;

      while (((beg=s.indexOf("<U>", beg)) != -1) && (!ende)){
         end = findTag(beg, s);
         beg++;
         tmp = beg;
         while (((tmp=s.indexOf("<U>", tmp)) != -1) && ((tmp=s.indexOf("<U>", tmp))<end)){
          while((pl=s.indexOf("<PL>", tmp))!=-1){
            if(pl>tmp) {
              bPL = false;
              break;
            }
            if(findTag(pl,s)>tmp){
              bPL =true;
              break;
            }
          }

          cnt++;
          if((cnt>=3)&&(!bPL)){
            s = deleteTag(findTag(tmp, s), "</U>");
            s = deleteTag(tmp, "<U>");
            end = findTag(beg, s);
          }
          tmp++;
         }
         cnt = 0;
      }
}


/**
 * Deletes a Tag in a Document.
 */
private String deleteTag(int index, String tag) {
   StringBuffer newString = new StringBuffer(s);
   return newString.delete(index, index+tag.length()).toString();
}

/**
 * find the close tag to the given start tag
 */
 private int findTag(int pos, String s){
    int end=pos+1;
    int oldPos=0;

    pos++;
    while(true){
      if(pos<1) break;

      pos=s.indexOf("<U>" ,pos);
      end=s.indexOf("</U>", end);
      if((pos!=-1)&&(pos<end)){
        pos++;
        end++;
        end=s.indexOf("</U>", end);
        pos=s.indexOf("<U>" ,pos);
      }
      else
       break;
    }

    return end;
 }

 private int findTagPL(int pos, String s){
    int end=pos;
    int oldPos=0;

    pos++;
    while(true){
      if(pos==-1) break;

      pos=s.indexOf("<PL>" ,pos);
      end=s.indexOf("</PL>", end);
      if((pos!=-1)&&(pos<end)){
        pos++;
        end++;
        end=s.indexOf("</PL>", end);
        pos=s.indexOf("<PL>" ,pos);
      }
      else
       break;
    }

    return end;
 }

 public void breakIt() {
   this.ende=true;
}
}