package icfp2001;

/* *************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

public class delTagSpace implements Runnable {

private Thread           thread;
private String s = null;
private boolean ende = false;

  public delTagSpace() {
  }

/**
 * Starts the Thread.
 */
public void startMe(String s) {
   this.s = s;

   thread = new Thread( this );
   thread.start();
}


/**
 * Returns the String.
 */
public String getString() {
   return s;
}

/**
 * Checks the Thread: running?
 */
public boolean isAlive() {
   if ( thread != null )
      return thread.isAlive();
   return false;
}


/**
 * Starts the Thread.
 */
public void run() {
  int pos=0;
  char chr;
  int cnt = 0;
  int first=0, last=0;

  //check the complete document
  int ln = s.length();
  while((pos<s.length()) && (!ende)){

   //search ' ' to delete
    if(s.charAt(pos)=='<'){//new tag
      pos++;
      if((s.charAt(pos)=='T')||(s.charAt(pos)=='U')){//text or underline open tag
       cnt ++;
       pos++;
      }
      else if(s.charAt(pos)=='/'){//new close tag
        pos++;
        if((s.charAt(pos)=='T')||(s.charAt(pos)=='U')){//text or underline close tag
           cnt --;
           pos++;
        }
      }
    }
    else if(s.charAt(pos)==' '){//space
      //not betweeen <TT> or <U> tags
      if(cnt==0){
        first = pos - 1;
        last = pos + 1;
        if(last>=s.length())break;
        if(s.charAt(first)=='>'){
          while(true){
            if(last>=s.length())break;
            if(s.charAt(last)=='<'){
                s = delete(pos, s);
                break;
            }
            else if(s.charAt(last)==' '){
              s = delete(last, s);
            }
            else {
                pos ++;
                break;
            }
          }//while
        }//if >
        else {
          pos++;
        }
      }//if cnt==0
      else {
        pos++;
      }
    }
    //normal char
    else{
      pos++;
    }
  }//while
}


/**
 * Deletes a " " in a Document.
 */
private String delete(int index, String s) {
   StringBuffer newString = new StringBuffer(s);
      newString.deleteCharAt(index);

   return newString.toString();
}

public void breakIt() {
   this.ende=true;
}

}