package icfp2001;

/* *************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

public class WhitespaceCompession implements Runnable {

private Thread           thread;
private String s = null;
private boolean ende = false;

private String[] startTags = {"<B>","<I>","<PL>","<S>","<TT>","<0>","<1>",
                              "<2>","<3>", "<4>","<5>", "<6>","<7>","<8>",
                              "<9>","<r>", "<g>","<b>", "<c>","<m>","<y>",
                              "<k>","<w>"};
private String[] endTags =   {"</B>","</I>","</PL>","</S>","</TT>","</0>",
                              "</1>","</2>","</3>", "</4>","</5>", "</6>",
                              "</7>","</8>","</9>", "</r>","</g>", "</b>",
                              "</c>","</m>","</y>", "</k>","</w>"};

  public WhitespaceCompession() {
  }

public void startMe(String s) {
   this.s = s;

   thread = new Thread( this );
   thread.start();
}

/**
 * Returns the String.
 */
public String getString() {
   return s;
}

  public void run(){
      int beg=0;
      int act=0;
      int search = 0;
      int counter = 0;
      boolean tt = false;

      while (((beg=s.indexOf(" ", beg)) != -1) && (!ende))
      {
         beg++;
         if (beg>=s.length()) break;
         act = beg;
         counter = 0;
         search = 0;
         while(((search=s.indexOf(startTags[4], search))!=-1)){
           if(beg>search){
            search ++;
            counter++;
           }
           else break;
         }
         search = 0;
         if(counter>0){
          while(((search=s.indexOf(endTags[4], search))!=-1)){
           if(beg>search){
            search ++;
            counter--;
           }
           else break;
          }
         }
        if(counter==0){
         while (((s.charAt(act))==' '))
         {
            s = delete(act, s);
            if (act>=s.length()) break;
         }
         tt = false;
        }
      }

  }

  public boolean isAlive() {
        if ( thread != null )
            return thread.isAlive();

        return false;
    }

/**
 * Deletes a " " in a Document.
 */
private String delete(int index, String s) {
   StringBuffer newString = new StringBuffer(s);
      newString.deleteCharAt(index);

   return newString.toString();
}

public void breakIt() {
   this.ende=true;
}
}